/* LatVis
 * Copyright (C) 2002 Jan Outrata <outrataj@phoenix.inf.upol.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// class of the file loader

#ifndef __FILE_LOADER_H__
#define __FILE_LOADER_H__

#include "orderedsets.h"
#include <string>

class FileLoader {
 public:
  enum type_t {NOTYPE, XML};
  enum error_t {EOK, ETYPE, EACCESS, ELOAD};
 protected:
  OrderedSets *orderedsets;

  bool goodXML(void *doc, OrderedSet *os, string filename);
  // frees doc, sets file of os to filename
  // retirns: true
  bool failXML(void *doc, OrderedSet *os);
  // frees doc and os
  // returns: false
  bool loadFromXML(string filename, OrderedSet *&os);
  // loads the set from the XML file filename
  // returns: if successful (not), set in os
 public:
  FileLoader(OrderedSets *oss);
  ~FileLoader() {}
  error_t load(string filename, type_t type, OrderedSet *&os);
  // loads the set from the file filename, of type type
  // returns: if successful (not), set in os
};

#endif
