/* LatVis
 * Copyright (C) 2002 Jan Outrata <outrataj@phoenix.inf.upol.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "appbuttons.h"
#include "i18n.h"
#include <gtk--/togglebutton.h>
#include <stdio.h>

AppButtons::AppButtons()
  : Gtk::Table(5, 2, TRUE)
{
  button = SELECT;
  button_count = 8;
  buttons = new Gtk::ToggleButton * [button_count];
  buttons[0] = manage(new Gtk::ToggleButton(_("Select")));
  buttons[0]->clicked.connect(SigC::bind<button_t>
			      (SigC::slot(*this, &AppButtons::selectButton),
			       SELECT));
  attach(*buttons[0], 0, 1, 0, 1);
  buttons[0]->show();
  buttons[1] = manage(new Gtk::ToggleButton(_("New")));
  buttons[1]->clicked.connect(SigC::bind<button_t>
			      (SigC::slot(*this, &AppButtons::selectButton),
			       NEW));
  attach(*buttons[1], 0, 1, 1, 2);
  buttons[1]->show();
  buttons[2] = manage(new Gtk::ToggleButton(_("Remove")));
  buttons[2]->clicked.connect(SigC::bind<button_t>
			      (SigC::slot(*this, &AppButtons::selectButton),
			       REMOVE));
  attach(*buttons[2], 1, 2, 1, 2);
  buttons[2]->show();
  buttons[3] = manage(new Gtk::ToggleButton(_("Define cover")));
  buttons[3]->clicked.connect(SigC::bind<button_t>
			      (SigC::slot(*this, &AppButtons::selectButton),
			       COVER));
  attach(*buttons[3], 0, 1, 2, 3);
  buttons[3]->show();
  buttons[4] = manage(new Gtk::ToggleButton(_("Remove cover")));
  buttons[4]->clicked.connect(SigC::bind<button_t>
			      (SigC::slot(*this, &AppButtons::selectButton),
			       REMOVE_COVER));
  attach(*buttons[4], 1, 2, 2, 3);
  buttons[4]->show();
  buttons[5] = manage(new Gtk::ToggleButton(_("Mark lower")));
  buttons[5]->clicked.connect(SigC::bind<button_t>
			      (SigC::slot(*this, &AppButtons::selectButton),
			       MARK_LOWER));
  attach(*buttons[5], 0, 1, 3, 4);
  buttons[5]->show();
  buttons[6] = manage(new Gtk::ToggleButton(_("Mark upper")));
  buttons[6]->clicked.connect(SigC::bind<button_t>
			      (SigC::slot(*this, &AppButtons::selectButton),
			       MARK_UPPER));
  attach(*buttons[6], 1, 2, 3, 4);
  buttons[6]->show();
  buttons[7] = manage(new Gtk::ToggleButton(_("Mark paths")));
  buttons[7]->clicked.connect(SigC::bind<button_t>
			      (SigC::slot(*this, &AppButtons::selectButton),
			       MARK_PATHS));
  attach(*buttons[7], 0, 1, 4, 5);
  buttons[7]->show();
  // buttons may grow
  buttons[0]->set_active(true);
  show();
}
  
void
AppButtons::selectButton(button_t b)
{
  char but = button;
  
  if (button == -1) return;
  button = -1;
  if (but != b) buttons[but]->set_active(false);
  buttons[b]->set_active(true);
  button = b;
}
