/* LatVis
 * Copyright (C) 2002 Jan Outrata <outrataj@phoenix.inf.upol.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// class of the diagram window popup menu

#ifndef __DIAGRAMPOPUPMENU_H__
#define __DIAGRAMPOPUPMENU_H__

#include "orderedsets.h"
#include <gtk--/menu.h>

class DiagramWindow;
class DiagramArea;
class AppWindow;
class AppButtons;
class SaveAsFileDialog;
class RearrangeDiagramDialog;

class DiagramPopupMenu : public Gtk::Menu {
 public:
  enum modes_t {MODE_SELECT, MODE_NEW, MODE_REMOVE, MODE_COVER,
                MODE_REMOVE_COVER, MODE_MARK_UPPER, MODE_MARK_LOWER,
		MODE_MARK_PATHS};
 protected:
  OrderedSets *orderedsets;
  OrderedSet *orderedset;
  AppWindow *appwindow;
  DiagramWindow *window;
  DiagramArea *area;
  AppButtons *appbuttons;
  SaveAsFileDialog *saveasfile_dialog;
  RearrangeDiagramDialog *rearrangediagram_dialog;
  gint x_menu, y_menu;
  void save();
  void saveAs();
  void undo();
  void redo();
  void cut();
  void copy();
  void paste();
  void clear();
  void selectInvert();
  void selectAll();
  void selectNone();
  void selectMarked();
  void selectElements();
  void newDiagramView();
  void newElements();
  void renameElement();
  void removeElements();
  void coverElements();
  void removeCover();
  void rearrangeDiagram();
  void markUpper();
  void markLower();
  void markMinimal();
  void markMaximal();
  void markLeast();
  void markGreatest();
  void markLowerCone();
  void markUpperCone();
  void markInfimum();
  void markSupremum();
  void markPaths();
  void unmarkAll();
 public:
  DiagramPopupMenu(AppWindow *appwin, DiagramWindow *win, 
		   OrderedSets *oss, OrderedSet *os);
  ~DiagramPopupMenu();
  void setArea(DiagramArea *a) { area = a; }
  void popup(int x, int y, guint button, guint32 activate_time);
  modes_t getMode();
};

#endif
