/* LatVis
 * Copyright (C) 2002 Jan Outrata <outrataj@phoenix.inf.upol.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// class of the command line options

#ifndef __OPTIONS_H__
#define __OPTIONS_H__

#include <string>

// MSVC wants this
using namespace std;

class Options {
 public:
  enum diagram_method_t {OPTION_DIAGRAM_METHOD_NONE,
			 OPTION_DIAGRAM_METHOD_LEVEL, 
			 OPTION_DIAGRAM_METHOD_GEOMETRIC,
			 OPTION_DIAGRAM_METHOD_LAYER};
 protected:
  int argc;
  char **argv;
  bool help;
  bool version;
  bool diagram;
  diagram_method_t diagram_method;
  bool save;
  unsigned short file_index;
  void parse();
 public:
  Options(int argc_, char *argv_[]);
  bool getHelp() { return help; }
  bool getVersion() { return version; }
  bool getDiagram() { return diagram; }
  diagram_method_t getDiagramMethod() { return diagram_method; }
  bool getSave() { return save; }
  string getNextFilename();
  void printHelp();
  void printVersion();
};

#endif
